'use strict';

var co = require('co');

module.exports = function (app) {
  var onerror = app.context.onerror;

  var wrapper = function *() {
    yield this.teardownCallbacks;
  };

  app.context.onerror = function (err) {
    var onerror_ = onerror.bind(this);

    if (!this.teardownCallbacks.length) {
      onerror_(err);
      return;
    }

    co(wrapper.bind(this))
      .then(function () {
        onerror_(err);
      })
      .catch(function (newerr) {
        onerror_(err || newerr);
      });
  };

  app.context.teardown = function (gen) {
    this.teardownCallbacks.push(gen.call(this));
  };

  return function *(next) {
    this.teardownCallbacks = [];
    yield* next;
  };
};
